﻿Type=Class
Version=4.19
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Custom View class

#DesignerProperty: key: Pattern, displayname: Pattern, fieldtype: String, defaultvalue: 
#DesignerProperty: key: Value, displayname: Value, fieldtype: String, defaultvalue: 
#DesignerProperty: key: BorderColor, displayname: Invalid Border Color, fieldtype: Color, defaultvalue: FFFD121C
#DesignerProperty: key: BorderWidth, displayname: Invalid Border Width, fieldtype: Int, defaultvalue: 2
Sub Class_Globals
	Private fx As JFX
	Private EventName As String 'ignore
	Private CallBack As Object 'ignore
	Private tf As TextField
	Private val As String
	Private pattern As String
	Private mProps As Map
End Sub

Public Sub Initialize (vCallback As Object, vEventName As String)
	EventName = vEventName
	CallBack = vCallback
End Sub

Public Sub DesignerCreateView (Base As Pane, Lbl As Label, Props As Map)
	tf.Initialize("tf")
	tf.Style = Lbl.Style
	Base.AddNode(tf, 0, 0, 0, 0)
	pattern = Props.Get("Pattern")
	CSSUtils.SetBorder(Base, 0, fx.Colors.Black, 0)
	mProps = Props
	setValue(Props.Get("Value"))
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	tf.SetLayoutAnimated(0, 0, 0, Width, Height)
End Sub

Private Sub tf_TextChanged (Old As String, New As String)
	If Regex.IsMatch(pattern, New) Then
		val = New
		CSSUtils.SetBorder(tf, 0, fx.Colors.Black, 0)
	Else
		CSSUtils.SetBorder(tf, mProps.Get("BorderWidth"), mProps.Get("BorderColor"), 2)
	End If
End Sub

Public Sub getValue As String
	Return val
End Sub

Public Sub setValue (v As String)
	tf.Text = v
End Sub


